﻿/*
 * 
 * User: Emo 电子
 * Date: 2015/8/5
 * Time: 14:39
 * 
 * Shop:http://xiangyunzone.taobao.com
 * Blog:http://www.dzmxj.com
 * 
 * 此软件是由Emo电子开发的一个简单的串口调试助手，可作为单片机开发调试使用，
 * 以及入门串口c#编程学习使用。
 */
 
 
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.IO.Ports;
using System.IO;
using Microsoft.Win32;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;



namespace Emo串口助手
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		
		private bool IsOpen = false;
        private double sendnum = 0;
        private double receivenum = 0;
        private bool IsRxShow = false;
		//MainFrom初始化
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();		//窗体控件初始化

			initsetting();				//软件设置默认初始化

            Control.CheckForIllegalCrossThreadCalls = false;        //编辑器停止跨线程检测
		}
		
        //软件设置初始化
		private void initsetting()
        {
            RegistryKey keyCom = Registry.LocalMachine.OpenSubKey(@"Hardware\DeviceMap\SerialComm");//获取可用的串口号
            if (keyCom != null)
            {
                string[] sSubKeys = keyCom.GetValueNames();			//获取所有存在的串口号并以数组暂存
                this.cobport.Items.Clear();							//清除下拉列表
                foreach (string sName in sSubKeys)					//循环将端口信息添加到cobport中
                {
                    string sValue = (string)keyCom.GetValue(sName);
                    this.cobport.Items.Add(sValue);
                }
                this.cobport.SelectedIndex=0;						//默认初始化设置
                this.cobbaud.SelectedIndex=5;
                this.cobcheck.SelectedIndex=0;
                this.cobdata.SelectedIndex=3;
                this.cobstop.SelectedIndex=0;
                tssendnum.Text="0";
                tsreceivenum.Text="0";
                serialPort1.Encoding = Encoding.GetEncoding("GB2312");
                // 没有打开串口前可以失能接收发送操作
                // grbreceive.Enabled = false;
                // grbsend.Enabled = false;
            }
            else
            {	
            	//初始化失败，并推出软件
            	MessageBox.Show("无可用串口，初始化失败，软件将关闭！！");
            	this.Close();
            }
        }
		
        //打开串口操作事件
		void BtopenClick(object sender, EventArgs e)
		{
			if (IsOpen)
            {
            try
            {
               
            	//MessageBox.Show(comm.);
                if (serialPort1.IsOpen) serialPort1.Close();
                serialPort1.GetLifetimeService();
                IsOpen = false;
                btopen.Text = "打开串口";
                tsstatus.Text = "关闭串口成功！";
                btopen.Image = Properties.Resources.disconnect;
              // 没有打开串口前可以失能接收发送操作
              //  grbreceive.Enabled = false;
              //  grbsend.Enabled = false;

            }
            catch (System.Exception ex)
            {
                tsstatus.Text = "关闭串口失败！" + ex.Message;
            }
            }
            else
            {
                try
                {
                    if (serialPort1.IsOpen) serialPort1.Close();
                    serialPort1.PortName = cobport.Text;
                    serialPort1.BaudRate = Convert.ToInt32(cobbaud.Text);
                    serialPort1.DataBits = Convert.ToInt32(cobdata.Text);
                    serialPort1.ReceivedBytesThreshold = 1;
                    switch (cobcheck.SelectedIndex)
                    { 		
                        case 0:
                            serialPort1.Parity = Parity.None;
                            break;
                        case 1:
                            serialPort1.Parity = Parity.Odd;
                            break;
                        case 2:
                            serialPort1.Parity = Parity.Even;
                            break;
                        case 3:
                            serialPort1.Parity = Parity.Mark;
                            break;
                        case 4:
                            serialPort1.Parity = Parity.Space;
                            break;
                        default:
                            serialPort1.Parity = Parity.None;
                            break;
                    }
                    switch (cobstop.SelectedIndex)
                    {
                        case 0:
                            serialPort1.StopBits = StopBits.One;
                            break;
                        case 1:
                            serialPort1.StopBits = StopBits.OnePointFive;
                            break;
                        case 2:
                            serialPort1.StopBits = StopBits.Two;
                            break;
                        default:
                            serialPort1.StopBits = StopBits.One;
                            break;
                    }
                    serialPort1.Open();
                    IsOpen = true;
                    btopen.Text = "关闭串口";
                    btopen.Image = Properties.Resources.connect;
                   tsstatus.Text = "打开串口成功！";
                 // 没有打开串口前可以失能接收发送操作
                 //  grbreceive.Enabled = true;
                 //  grbsend.Enabled = true;
                }
                catch (System.Exception ex)
                {
                	tsstatus.Text = "打开串口失败！" + ex.Message;
                }
			}
		}
		
        //串口接收数据事件
        void SerialPort1DataReceived(object sender, SerialDataReceivedEventArgs e)
		{
            if (IsRxShow) return;
            if (!chbhexshow.Checked )
            {
                    string readtemp = serialPort1.ReadExisting();
                    //接收数据计数
                    Encoding gb = System.Text.Encoding.GetEncoding("gb2312");
                    Byte[] BytesMessage = gb.GetBytes(readtemp);
                    receivenum += BytesMessage.Length;
                    tsreceivenum.Text = "" + receivenum;
                    ribreceive.AppendText(readtemp);                              //串口类会自动处理汉字，所以不需要特别转换
                  //  ribreceive.ScrollToCaret();
                
            }
            else
			{
			    try
                {
                    byte[] data = new byte[serialPort1.BytesToRead];                                //定义缓冲区，因为串口事件触发时有可能收到不止一个字节
                    //接收数据计数
                    receivenum += data.Length;
                    tsreceivenum.Text = "" + receivenum;
                    serialPort1.Read(data, 0, data.Length);
                    foreach (byte Member in data)                                                   //遍历用法获取已接收的数据
                    {
                        string str = Convert.ToString(Member, 16).ToUpper();
                        ribreceive.AppendText((str.Length == 1 ? "0" + str : str)+" ");
                    //    ribreceive.ScrollToCaret();
                    }
                }
                catch {
                    MessageBox.Show("软件异常");
                }
			 }
            //自动清空选择后，当接收框数据大于4K即4096个字节后自动清除
            if (chbautoclean.Checked)
            {
                if (ribreceive.Text.Length > 4096) ribreceive.Text = "";
            }
		}
		
        //手动清空接收数据事件
		void BthandcleanClick(object sender, EventArgs e)
		{
			ribreceive.Text="";
		}
		
        //转换发送框数据格式
	    void ChbhexsendCheckedChanged(object sender, EventArgs e)
	    {
            if (chbhexsend.CheckState == CheckState.Checked)
            {
                if (ribsend.Text != "")
                {
                    ribsend.Text = ConvertStringToHex(ribsend.Text);
                }

            }
            else
            {
                if (ribsend.Text != "")
                {
                    ribsend.Text = ConvertHexToString(ribsend.Text);
                }
            }
	    }

        //是否选择使用hex显示模式
        private void chbhexshow_CheckedChanged(object sender, EventArgs e)
        {
            if (chbhexshow.CheckState == CheckState.Checked)
            {
                if (ribreceive.Text != "")
                {
                    ribreceive.Text = ConvertStringToHex(ribreceive.Text);
                }

            }
            else
            {
                if (ribreceive.Text != "")
                {
                    ribreceive.Text = ConvertHexToString(ribreceive.Text);
                }
            }
        }

      /*
       * 这两个方法是字符串与16进制直接的转换
       */
        //将字符串转换成Hex显示
        private string ConvertStringToHex(string asciiString)
            {
                string hex = "";
                asciiString = asciiString.Replace("\n", "\r\n");                //解决richTextBox获取不到"\r\n"换行符
                byte[] arrByte = System.Text.Encoding.GetEncoding("GB2312").GetBytes(asciiString);
                foreach (char c in arrByte)
                {
                    int tmp = c;
                    hex += String.Format("{0:x2}", (uint)System.Convert.ToUInt32(tmp.ToString())).ToUpper()+" ";
                }
                return hex;
            }

        //将Hex转换成字符串显示
        private string ConvertHexToString(string s)
            {
                string result = string.Empty;
                s = s.Replace(" ", "");
                byte[] arrByte = new byte[s.Length / 2];
                int index = 0;
                for (int i = 0; i < s.Length; i += 2)
                {
                    arrByte[index++] = Convert.ToByte(s.Substring(i, 2), 16);        //Convert.ToByte(string,16)把十六进制string转化成byte 
                }
                result = System.Text.Encoding.Default.GetString(arrByte);
                return result;
            }

        //是否使能串口RTS功能
        private void chbrts_CheckedChanged(object sender, EventArgs e)
        {
            if (chbrts.CheckState == CheckState.Checked)
                serialPort1.RtsEnable = true;
            else {
                serialPort1.RtsEnable = false;
            }
        }

        //是否使能串口DTR功能
        private void chbdtr_CheckedChanged(object sender, EventArgs e)
        {
            if (chbdtr.CheckState == CheckState.Checked)
                serialPort1.DtrEnable = true;
            else
            {
                serialPort1.DtrEnable = false;
            }
        }

        //输入离开发送窗体后激发此事件，用于校验数据是否为HEX格式
        private void ribsend_Leave(object sender, EventArgs e)
        {
            if (chbhexsend.CheckState == CheckState.Checked)
            {
                //    MessageBox.Show("leave");
                //十六进制发送时，发送框数据进行十六进制数据正则校验
                if (Regex.IsMatch(ribsend.Text.Replace(" ", ""), "^[0-9A-Fa-f]+$"))
                { 
                    //校验成功
                //    MessageBox.Show("is hex");
                }
               
                else
                {
                    //校验失败
                    MessageBox.Show("输入数据格式错误，请检查！！", "", MessageBoxButtons.OK, MessageBoxIcon.Warning);   //弹出警告窗体，提示错误信息
                    ribsend.Select();           //重新选择发送窗体，直到修改错误数据
                }
            }
        }

        //手动发送数据
        private void bthandsend_Click(object sender, EventArgs e)
        {
            senddata();
        }

        //发送数据
        private void senddata()
        {
            byte[] Data = new byte[1];
            if (serialPort1.IsOpen)
            {
                if (ribsend.Text != "")
                {
                    if (!chbhexsend.Checked)
                    {
                        try
                        {

                            Encoding gb = System.Text.Encoding.GetEncoding("gb2312"); 
                            Byte[] BytesMessage = gb.GetBytes(ribsend.Text);
                            //发送计数
                            sendnum += BytesMessage.Length;
                            tssendnum.Text = "" + sendnum;
                            
                            //串口以字符串的格式发送数据
                            serialPort1.Write(ribsend.Text);      
                        }
                        catch
                        {
                            MessageBox.Show("串口数据写入错误", "错误");
                        }
                    }
                    else
                    {
                        //去除空格字符
                        string temp = ribsend.Text;
                        temp = temp.Replace(" ", "");
                        //发送计数
                        sendnum += temp.Length/2;
                        tssendnum.Text = "" + sendnum;
                        //如果此时用户输入字符串中含有非法字符（字母，汉字，符号等等，try，catch块可以捕捉并提示）
                        try                                                                
                        {
                            for (int i = 0; i < (temp.Length - temp.Length % 2) / 2; i++)//转换偶数个
                            {
                                Data[0] = Convert.ToByte(temp.Substring(i * 2, 2), 16);           //转换
                                serialPort1.Write(Data, 0, 1);
                            }
                            if (temp.Length % 2 != 0)
                            {
                                Data[0] = Convert.ToByte(temp.Substring(temp.Length - 1, 1), 16);//单独处理最后一个字符
                                serialPort1.Write(Data, 0, 1);                              //写入
                            }
                        }
                        catch
                        {

                        }
                        //下面这种方法由于字符串格式的问题导致部分数据错乱
                        //temp = converthextostring(temp);
                        //try
                        //{
                        //    serialport1.write(temp);      //串口以字符串的格式发送数据
                        //}
                        //catch
                        //{
                        //    messagebox.show("串口数据写入错误", "错误");
                        //}
                    }
                }
            }
        }

        //自动发送事件
        private void chbautosend_CheckedChanged(object sender, EventArgs e)
        {
            //串口未打开时，不能使用串口自动发送数据
            if ((serialPort1.IsOpen == false) && (chbautosend.CheckState == CheckState.Checked))
            {
                //判断串口是未打开，且选择项是Checked状态，则提示错误信息，并清除勾选
                MessageBox.Show("串口未打开，请打开串口！！");
                //清除自动发送选择框状态
                chbautosend.CheckState = CheckState.Unchecked;
                //直接返回
                return; 
            }
            if (chbautosend.CheckState == CheckState.Checked)
            {
                //自动发送后，失能手动发送
                bthandsend.Enabled = false;
                int i;
                i = Convert.ToInt32(txbtimer.Text);
                if (i < 10 || i > 60000)
                {
                    i = 1000;
                    txbtimer.Text = "1000";
                    MessageBox.Show("自动发送周期范围为100-60000毫秒！","提示");
                }
                timer1.Interval = i;
                timer1.Enabled = true;
            }
            else
            {
                //关闭自动发送后，使能手动发送
                bthandsend.Enabled = true;
                timer1.Enabled = false;
            }
        }

        //定时发送
        private void timer1_Tick(object sender, EventArgs e)
        {
            senddata();
        }

        //清空发送区
        private void btcleansend_Click(object sender, EventArgs e)
        {
            if (ribsend.Text != "")
                ribsend.Text = "";

        }
        
        //清空数据计数
        private void 清空计数ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //清空相关数据
            sendnum = 0;
            receivenum = 0;
            tssendnum.Text = "0";
            tsreceivenum.Text = "0";
        }

        //接收区自动滚动
        private void ribreceive_TextChanged(object sender, EventArgs e)
        {
          //  this.ribreceive.Focus();//获取焦点
            this.ribreceive.Select(this.ribreceive.TextLength, 0);
            ribreceive.ScrollToCaret();
        }

        //暂停继续接收
        private void btshow_Click(object sender, EventArgs e)
        {
            if (!IsRxShow)
            {
                IsRxShow = true;
                btshow.Text = "暂停接收";
            }
            else
            {
                IsRxShow = false;
                btshow.Text = "继续接收";
            }
        }
        
        //清空数据计数
        private void toolStripStatusLabel2_Click(object sender, EventArgs e)
        {
            //清空相关数据
            sendnum = 0;
            receivenum = 0;
            tssendnum.Text = "0";
            tsreceivenum.Text = "0";
        }

       //以下为广告设置，不做要求 (*^__^*) 嘻嘻……
        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("http://xiangyunzone.taobao.com"); 
        }

        private void linkLabel1_MouseMove(object sender, MouseEventArgs e)
        {
            linkLabel1.LinkColor = Color.Red;
        }

        private void linkLabel1_MouseLeave(object sender, EventArgs e)
        {
            linkLabel1.LinkColor = Color.DimGray;
        }

        private void 关于我们ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("http://www.dzmxj.com"); 
        }



        //添加richbox 右键菜单（richtextbox和textbox不一样没有自带的右键菜单）
        private void contextMenuStrip1_Opening(object sender, System.ComponentModel.CancelEventArgs e)
        {

        }

        private void 清除_Click(object sender, EventArgs e)
        {
            Control c = this.contextMenuStrip1.SourceControl;
            string s= c.GetType().Name;
            if (c.GetType().Name == "RichTextBox")
            {
                RichTextBox RTB = (RichTextBox)contextMenuStrip1.SourceControl; 
                RTB.Clear();
            }
        }

        private void 复制_Click(object sender, EventArgs e)
        {
            Control c = this.contextMenuStrip1.SourceControl;
            string s = c.GetType().Name;
            if (c.GetType().Name == "RichTextBox")
            {
                RichTextBox RTB = (RichTextBox)contextMenuStrip1.SourceControl;
                RTB.Copy();
            }
        }

        private void 撤销_Click(object sender, EventArgs e)
        {
            Control c = this.contextMenuStrip1.SourceControl;
            string s = c.GetType().Name;
            if (c.GetType().Name == "RichTextBox")
            {
                RichTextBox RTB = (RichTextBox)contextMenuStrip1.SourceControl;
                if (RTB.CanUndo)
                {
                    RTB.Undo();
                }
            }
        }

        private void 剪切_Click(object sender, EventArgs e)
        {
            Control c = this.contextMenuStrip1.SourceControl;
            string s = c.GetType().Name;
            if (c.GetType().Name == "RichTextBox")
            {
                RichTextBox RTB = (RichTextBox)contextMenuStrip1.SourceControl;
                RTB.Cut();
            }
        }

        private void 全选_Click(object sender, EventArgs e)
        {
            Control c = this.contextMenuStrip1.SourceControl;
            string s = c.GetType().Name;
            if (c.GetType().Name == "RichTextBox")
            {
                RichTextBox RTB = (RichTextBox)contextMenuStrip1.SourceControl;
                RTB.SelectAll();
            }
        }

        private void 粘贴_Click(object sender, EventArgs e)
        {
            Control c = this.contextMenuStrip1.SourceControl;
            string s = c.GetType().Name;
            if (c.GetType().Name == "RichTextBox")
            {
                RichTextBox RTB = (RichTextBox)contextMenuStrip1.SourceControl;
                RTB.Paste();
            }
        }


     

	 }
}
